local ShadowUF = ShadowUF
local Five = {}

ShadowUF:RegisterModule(Five, "fiveOverlay", "5 Second Rule")

function Five:OnDefaultsSet()
	--[[for _, unit in pairs(ShadowUF.units) do
		ShadowUF.defaults.profile.units[unit].fiveOverlay = {enabled = false}
	end--]]
	ShadowUF.defaults.profile.units.player.fiveOverlay = {enabled = true}
end

function Five:OnConfigurationLoad()
	ShadowUF.Config.unitTable.args.bars.args.bar.args.fiveOverlay = {
		type = "toggle",
		order = 1,
		name = "5 Second Rule",
		desc = "5SR overlay on the power bar",
		arg = "fiveOverlay.enabled",
		hidden = ShadowUF.Config.hideRestrictedOption,
		disabled = function(info)
			local unit = type(info.arg) == "number" and info[#(info) - info.arg] or info[2]
			return not ShadowUF.db.profile.units[unit].powerBar.enabled
		end,
	}
end

local mana_regen_wait = 5 -- okay, okay, this is unlikely to change. BUT!
local function updateFiveSecondRule(bar, t)
	local timediff = GetTime() - bar.spellcast_finish_time
	if timediff > mana_regen_wait then
		-- it's been more than five seconds, get rid of the spark
		bar:Hide()
	else
		-- move the spark a little
		bar.texture:SetPoint('LEFT', bar, 'LEFT', (timediff / mana_regen_wait) * (bar:GetWidth() - 1) - 10, 0)
	end	
end

function Five:OnEnable(frame)
	if not frame.visibility.powerBar then return end -- the spark is pretty meaningless without the powerbar
	local _, playerClass = UnitClass(frame.unit)
	if playerClass == "WARRIOR" or playerClass == "ROGUE" or playerClass == "DEATHKNIGHT" then
		return
	end
	
	if not frame.fiveOverlay then
		frame.fiveOverlay = CreateFrame("Frame", frame)
		frame.fiveOverlay:SetScript("OnUpdate", updateFiveSecondRule)

		local texture = frame.fiveOverlay:CreateTexture(nil, "OVERLAY")
		texture:SetPoint("LEFT", frame.fiveOverlay)
		texture:SetTexture("Interface\\CastingBar\\UI-CastingBar-Spark")
		texture:SetVertexColor(1, 1, 1, 0.6) -- config this?
		texture:SetBlendMode('ADD')
		texture:SetWidth(20)
		texture:Show()
		frame.fiveOverlay.texture = texture

		frame.fiveOverlay.current_mana = UnitMana(frame.unit)
		frame.fiveOverlay.spellcast_finish_time = 0
		frame.fiveOverlay.last_spellcast = 0
	end
	
	frame:RegisterUnitEvent("UNIT_MANA", self, "UnitMana")
	frame:RegisterUnitEvent("UNIT_SPELLCAST_SUCCEEDED", self, "CastSucceeded")
	if playerClass == "DRUID" then
		frame:RegisterUnitEvent("UNIT_DISPLAYPOWER", self, "DisplayPower")
	end
end

function Five:OnDisable(frame, unit)
	frame:UnregisterAll(self)
end

function Five:OnLayoutApplied(frame)
	if not frame.fiveOverlay or not frame.powerBar then
		if frame.fiveOverlay then
			frame.fiveOverlay:Hide()
		end
		return
	end
	
	frame.fiveOverlay:SetAllPoints(frame.powerBar)
	frame.fiveOverlay:SetFrameStrata(frame.powerBar:GetFrameStrata())
	frame.fiveOverlay:SetFrameLevel(frame.powerBar:GetFrameLevel() + 1)
	if GetTime() >= frame.fiveOverlay.spellcast_finish_time then
		frame.fiveOverlay:Hide()
	end
end

function Five:UnitMana(frame, event, unit)
	local mana = UnitMana(unit)
	if mana == UnitManaMax(unit) then
		frame.fiveOverlay:Hide()
	elseif mana < frame.fiveOverlay.current_mana then
		frame.fiveOverlay.spellcast_finish_time = frame.fiveOverlay.last_spellcast
		frame.fiveOverlay:Show()
	end
	frame.fiveOverlay.current_mana = mana
end

function Five:CastSucceeded(frame, event, unit)
	frame.fiveOverlay.last_spellcast = GetTime()
end

function Five:DisplayPower(frame, event, unit)
	if UnitPowerType(unit) == 0 then
		frame.fiveOverlay:Hide()
	else
		frame.fiveOverlay.current_mana = UnitMana(unit)
		frame.fiveOverlay:Show()
	end
end

